clang-tools 10.0.0

Public Member Functions | Public Attributes | List of all members
clang::doc::Reference Struct Reference

`#include <Representation.h>`

Inheritance diagram for clang::doc::Reference:
[legend]
Collaboration diagram for clang::doc::Reference:
[legend]

## Public Member Functions
| Reference ()=default
| Reference (llvm::StringRef Name)
| Reference (llvm::StringRef Name, StringRef Path)
| Reference (SymbolID USR, StringRef Name, InfoType IT)
| Reference (SymbolID USR, StringRef Name, InfoType IT, StringRef Path)
bool | operator== (const Reference &Other) const
bool | mergeable (const Reference &Other)
void | merge (Reference &&I)

## Public Attributes
SymbolID | USR = SymbolID()
SmallString< 16 > | Name
InfoType | RefType = InfoType::IT_default
llvm::SmallString< 128 > | Path
bool | IsInGlobalNamespace = false

## Detailed Description

Definition at line 115 of file Representation.h.

## Constructor & Destructor Documentation

## ◆ Reference() [1/5]

clang::doc::Reference::Reference | ( |  | ) |
| default

## ◆ Reference() [2/5]

clang::doc::Reference::Reference | ( | llvm::StringRef | Name | ) |
| inline

Definition at line 117 of file Representation.h.

## ◆ Reference() [3/5]

clang::doc::Reference::Reference | ( | llvm::StringRef | Name,
|  | StringRef | Path
| ) |  |
| inline

Definition at line 120 of file Representation.h.

## ◆ Reference() [4/5]

clang::doc::Reference::Reference | ( | SymbolID | USR,
|  | StringRef | Name,
|  | InfoType | IT
| ) |  |
| inline

Definition at line 122 of file Representation.h.

## ◆ Reference() [5/5]

clang::doc::Reference::Reference | ( | SymbolID | USR,
|  | StringRef | Name,
|  | InfoType | IT,
|  | StringRef | Path
| ) |  |
| inline

Definition at line 126 of file Representation.h.

## Member Function Documentation

## ◆ merge()

void clang::doc::Reference::merge | ( | Reference && | I | ) |

Definition at line 121 of file Representation.cpp.

References IsInGlobalNamespace, mergeable(), Name, and Path.

## ◆ mergeable()

bool clang::doc::Reference::mergeable | ( | const Reference & | Other | ) |

Definition at line 117 of file Representation.cpp.

References RefType, and USR.

Referenced by merge(), clang::doc::NamespaceInfo::merge(), clang::doc::SymbolInfo::merge(), clang::doc::FunctionInfo::merge(), clang::doc::RecordInfo::merge(), clang::doc::EnumInfo::merge(), and clang::doc::Info::mergeBase().

## ◆ operator==()

bool clang::doc::Reference::operator== | ( | const Reference & | Other | ) | const
| inline

Definition at line 130 of file Representation.h.

References Name, Name, RefType, and USR.

## Member Data Documentation

## ◆ IsInGlobalNamespace

bool clang::doc::Reference::IsInGlobalNamespace = false

Definition at line 148 of file Representation.h.

Referenced by clang::doc::ClangDocBitcodeWriter::emitBlock(), clang::doc::genReference(), llvm::yaml::MappingTraits< Reference >::mapping(), and merge().

## ◆ Name

SmallString<16> clang::doc::Reference::Name

Definition at line 139 of file Representation.h.

Referenced by clang::doc::ClangDocBitcodeWriter::emitBlock(), clang::doc::Info::extractName(), clang::doc::genReference(), llvm::yaml::MappingTraits< Reference >::mapping(), merge(), clang::doc::Info::mergeBase(), clang::doc::Index::operator<(), and operator==().

## ◆ Path

llvm::SmallString<128> clang::doc::Reference::Path

Definition at line 145 of file Representation.h.

Referenced by clang::doc::ClangDocBitcodeWriter::emitBlock(), clang::doc::genReference(), llvm::yaml::MappingTraits< Reference >::mapping(), merge(), and clang::doc::Info::mergeBase().

## ◆ RefType

InfoType clang::doc::Reference::RefType = InfoType::IT_default

Definition at line 140 of file Representation.h.

Referenced by clang::doc::ClangDocBitcodeWriter::emitBlock(), llvm::yaml::MappingTraits< Reference >::mapping(), mergeable(), and operator==().

## ◆ USR

SymbolID clang::doc::Reference::USR = SymbolID()

Definition at line 138 of file Representation.h.

Referenced by clang::doc::ClangDocBitcodeWriter::emitBlock(), clang::doc::Info::extractName(), llvm::yaml::MappingTraits< Reference >::mapping(), mergeable(), clang::doc::Info::mergeable(), clang::doc::Info::mergeBase(), and operator==().

The documentation for this struct was generated from the following files:

- Representation.h
- Representation.cpp